<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Doom Emacs</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - Doom Emacs
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Doom Emacs</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org5dd445f">Installation</a>
<ul>
<li><a href="#orgbf2f32f">Installing dependencies</a></li>
<li><a href="#org0666fe3">Installing Doom Emacs</a></li>
</ul>
</li>
<li><a href="#org9577740">Utilities found in bin/doom</a>
<ul>
<li><a href="#org7c69548">doom sync:</a></li>
<li><a href="#org4f40ee5">doom upgrade:</a></li>
<li><a href="#orgce8e9f3">doom upgrade &#x2013;packages</a></li>
<li><a href="#org8a19e3e">doom doctor:</a></li>
<li><a href="#org5392da0">doom purge:</a></li>
<li><a href="#org33d1e36">doom env:</a></li>
<li><a href="#orgf8e9122">doom help:</a></li>
</ul>
</li>
<li><a href="#orgb0e8c8a">DOOMDIR</a></li>
<li><a href="#org88cb566">Configuration Files</a>
<ul>
<li><a href="#orge79ae7b">init.el</a></li>
<li><a href="#orgf49c61a">config.el</a></li>
<li><a href="#org92d9ff6">packages.el</a></li>
</ul>
</li>
<li><a href="#orgfea1f48">Package management</a>
<ul>
<li><a href="#org7a52327">To install a package&#x2026;</a>
<ul>
<li><a href="#org630d61e">Footer</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org5dd445f" class="outline-2">
<h2 id="org5dd445f">Installation</h2>
<div class="outline-text-2" id="text-org5dd445f">
</div>
<div id="outline-container-orgbf2f32f" class="outline-3">
<h3 id="orgbf2f32f">Installing dependencies</h3>
<div class="outline-text-3" id="text-orgbf2f32f">
<ul class="org-ul">
<li>Git 2.23+</li>
<li>Emacs 26.1+ (27.x is recommended)</li>
<li>ripgrep 11.0+</li>
<li>GNU Find</li>
<li>(Optional) fd 7.3.0+ (known as fd-find on Debian, Ubuntu &amp; derivatives) – improves performance for many file indexing commands</li>
</ul>
</div>
</div>
<div id="outline-container-org0666fe3" class="outline-3">
<h3 id="org0666fe3">Installing Doom Emacs</h3>
<div class="outline-text-3" id="text-org0666fe3">
<ul class="org-ul">
<li>git clone <a href="https://github.com/hlissner/doom-emacs">https://github.com/hlissner/doom-emacs</a> ~/.emacs.d</li>
<li><p>
~/.emacs.d/bin/doom install
</p>

<p>
<i>doom install</i> will set up your DOOMDIR at ~/.doom.d (if it doesn’t already exist) and will work you through the first-time setup of Doom Emacs. Carefully follow any instructions it puts out. If this is your first time, you should run <i>doom doctor</i>. This will diagnose common issues with your system or config.
</p></li>
</ul>
</div>
</div>
</div>
<div id="outline-container-org9577740" class="outline-2">
<h2 id="org9577740">Utilities found in bin/doom</h2>
<div class="outline-text-2" id="text-org9577740">
</div>
<div id="outline-container-org7c69548" class="outline-3">
<h3 id="org7c69548">doom sync:</h3>
<div class="outline-text-3" id="text-org7c69548">
<p>
This synchronizes your config with Doom Emacs. It ensures that needed packages are installed, orphaned packages are removed and necessary metadata correctly generated. Run this whenever you modify your doom! block or packages.el file. You’ll need doom sync -u if you override the recipe of package installed by another module.
</p>
</div>
</div>
<div id="outline-container-org4f40ee5" class="outline-3">
<h3 id="org4f40ee5">doom upgrade:</h3>
<div class="outline-text-3" id="text-org4f40ee5">
<p>
Updates Doom Emacs (if available) and all its packages. Doom is an active project and many of its 300+ packages are in active development as well. It is wise to occasionally update
</p>
</div>
</div>
<div id="outline-container-orgce8e9f3" class="outline-3">
<h3 id="orgce8e9f3">doom upgrade &#x2013;packages</h3>
<div class="outline-text-3" id="text-orgce8e9f3">
<p>
To update only your packages (and not Doom itself)
</p>
</div>
</div>
<div id="outline-container-org8a19e3e" class="outline-3">
<h3 id="org8a19e3e">doom doctor:</h3>
<div class="outline-text-3" id="text-org8a19e3e">
<p>
If Doom misbehaves, the doc will diagnose common issues with your installation, system and environment.
</p>
</div>
</div>
<div id="outline-container-org5392da0" class="outline-3">
<h3 id="org5392da0">doom purge:</h3>
<div class="outline-text-3" id="text-org5392da0">
<p>
Over time, the repositories for Doom’s plugins will accumulate. Run this command from time to time to delete old, orphaned packages, and with the -g switch to compact existing package repos.
</p>
</div>
</div>
<div id="outline-container-org33d1e36" class="outline-3">
<h3 id="org33d1e36">doom env:</h3>
<div class="outline-text-3" id="text-org33d1e36">
<p>
(Re)generates an “envvar file”, which is a snapshot of your shell environment that Doom loads at startup. If your app launcher or OS launches Emacs in the wrong environment you will need this. This is required for GUI Emacs users on MacOS.
</p>
</div>
</div>
<div id="outline-container-orgf8e9122" class="outline-3">
<h3 id="orgf8e9122">doom help:</h3>
<div class="outline-text-3" id="text-orgf8e9122">
<p>
An overview of the available commands that doom provides. Use <i>doom help</i> COMMAND to display documentation for a particular COMMAND.
</p>

<p>
<code>NOTE:</code> I recommend you add your .emacs.d/bin to your PATH so you can call doom directly and from anywhere. Accomplish this by adding this to your .bashrc or .zshrc file:
</p>
<pre class="example" id="org06d133f">
export PATH=”$HOME/.emacs.d/bin:$PATH”
</pre>
</div>
</div>
</div>
<div id="outline-container-orgb0e8c8a" class="outline-2">
<h2 id="orgb0e8c8a">DOOMDIR</h2>
<div class="outline-text-2" id="text-orgb0e8c8a">
<p>
You can configure Doom by tweaking the files found in your <code>DOOMDIR</code>. Doom expects this directory to be found in one of:
</p>
<ul class="org-ul">
<li>~/.config/doom (respects $XDG_CONFIG_HOME)</li>
<li>~/.doom.d</li>
</ul>

<p>
This directory is referred to as your <code>DOOMDIR</code>. Only one of these directories should exist (Doom will only recognize one).
</p>
</div>
</div>
<div id="outline-container-org88cb566" class="outline-2">
<h2 id="org88cb566">Configuration Files</h2>
<div class="outline-text-2" id="text-org88cb566">
</div>
<div id="outline-container-orge79ae7b" class="outline-3">
<h3 id="orge79ae7b">init.el</h3>
<div class="outline-text-3" id="text-orge79ae7b">
<p>
Where you’ll find your doom! block, which controls what Doom modules are enabled and in what order they will be loaded. This file is evaluated early when Emacs is starting up; before any other module has loaded. You generally shouldn’t add code to this file unless you’re targeting Doom’s CLI or something that needs to be configured very early in the startup process.
</p>
</div>
</div>
<div id="outline-container-orgf49c61a" class="outline-3">
<h3 id="orgf49c61a">config.el</h3>
<div class="outline-text-3" id="text-orgf49c61a">
<p>
Here is where 99.99% of your private configuration should go. Anything in here is evaluated after all other modules have loaded, when starting up Emacs.
</p>
</div>
</div>
<div id="outline-container-org92d9ff6" class="outline-3">
<h3 id="org92d9ff6">packages.el</h3>
<div class="outline-text-3" id="text-org92d9ff6">
<p>
Package management is done from this file; where you’ll declare what packages to install and where from.
</p>
</div>
</div>
</div>
<div id="outline-container-orgfea1f48" class="outline-2">
<h2 id="orgfea1f48">Package management</h2>
<div class="outline-text-2" id="text-orgfea1f48">
<p>
Doom Emacs does not use <b><b>package.el</b></b> (the package manager built into Emacs). Packages are declared in packages.el files (in DOOMDIR).
</p>
</div>
<div id="outline-container-org7a52327" class="outline-3">
<h3 id="org7a52327">To install a package&#x2026;</h3>
<div class="outline-text-3" id="text-org7a52327">
<p>
Add a package! declaration for it to DOOMDIR/packages.el:
</p>

<div class="org-src-container">
<pre class="src src-elisp"><span style="color: #5B6268; font-style: italic;">;; </span><span style="color: #5B6268; font-style: italic;">Install a package named "example" from ELPA, MELPA, or Emacsmirror</span>
<span style="color: #51afef;">(</span><span style="color: #51afef; font-style: italic;">package!</span> example<span style="color: #51afef;">)</span>
</pre>
</div>

<p>
<code>IMPORTANT:</code> New packages won’t be installed until you run doom sync. <code>DO NOT</code> configure packages here (definitely no use-package! or after! in here!). This file is read in an isolated environment and will have no lasting effect.
</p>
</div>

<div id="outline-container-org630d61e" class="outline-4">
<h4 id="org630d61e">Footer</h4>
<div class="outline-text-4" id="text-org630d61e">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
